import sys,os,re

from .NAPS import NAPS
sys.path.append(re.sub('blues_lib.*','blues_lib',os.path.realpath(__file__)))
from model.models.BaiJiaDBModelFactory import BaiJiaDBModelFactory
from sele.loginer.baijia.BaiJiaLoginerFactory import BaiJiaLoginerFactory   

class BaiJiaNAPS(NAPS):

  def set_publish_plan(self):
    self.publish_plan = {
      'events':1,
      'news':1,
    }
    
  def _get_loginer(self):
    loginer_factory = BaiJiaLoginerFactory()
    return loginer_factory.create_account()

  def _get_models(self):
    query_condition = {
      'mode':'latest',
      'count':self.total,
    }
    factory = BaiJiaDBModelFactory()
    return factory.create(self.publish_plan,query_condition)
